package com.bergerkiller.bukkit.nolagg;

import java.util.logging.Level;

import net.minecraft.server.Chunk;

import org.bukkit.craftbukkit.util.EntryBase;
import org.bukkit.craftbukkit.util.LongHashtable;

public class BufferedLongHashtable extends LongHashtable<Chunk> {
	
	public BufferedLongHashtable(LongHashtable<Chunk> input) {
	    for (EntryBase entry : input.entries()) {
	    	super.put(entry);
	    }
	}
	
	public synchronized void put(long key, Chunk value) {
		if (value instanceof BufferedChunk) {
			if (((BufferedChunk) value).isFree()) {
				NoLagg.log(Level.SEVERE, "Someone re-introduced an unloaded buffered chunk into the chunk provider!");
				Thread.dumpStack();
			}
		}
		super.put(key, value);
	}

}
